//+------------------------------------------------------------------+
//|                                                 scal+marting.mq4 |
//+------------------------------------------------------------------+

#property copyright "Maloma"
#include <stdlib.mqh>

       int    StateOld = 0;
       int    StateCur = 0;
extern double Lots     = 1;
extern double Slippage = 3;
extern int    Grid     = 20;
extern int    Magic    = 110705;
extern bool   FixedLot = true;
extern bool   Stop     = false;

   double SellWorkPrice;
   double Spred;
   double BuyWorkPrice;
   double BuyStopPrice;
   double BuyStopProfit;
   double SellLimitPrice;
   double SellLimitProfit;
   double BuyLimitPrice;
   double BuyLimitProfit;
   double SellStopPrice;
   double SellStopProfit;
   double LotCount = 1;
   int    BuyStopCnt, BuyLimitCnt, SellStopCnt, SellLimitCnt;
   double BSLot, BLLot, SSLot, SLLot;
   
//+------------------------------------------------------------------+
int start()
  {
   bool pass  =false;
   bool First =true;
   bool ModOk;
   int TrueOrder, TrueBuy, TrueSell;
   
   RefreshRates();
   Spred = Ask-Bid;   
   if (OrdersTotal() > 0) {First = false;}
   if (First) {GoFirst();}
   BuyStopCnt=0;
   BuyLimitCnt=0;
   SellStopCnt=0;
   SellLimitCnt=0;
   for (int cnt=OrdersTotal()-1;cnt>=0;cnt--)
       {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
        if (OrderType()==OP_BUYSTOP) {BuyStopCnt++;}
        if (OrderType()==OP_BUYLIMIT) {BuyLimitCnt++;}
        if (OrderType()==OP_SELLSTOP) {SellStopCnt++;}
        if (OrderType()==OP_SELLLIMIT) {SellLimitCnt++;}
       }
   if ((BuyStopCnt==0) || (BuyLimitCnt==0) || (SellStopCnt==0) || (SellLimitCnt==0))
      {pass=true;}
   else {pass=false;}

   if (!pass) {return(0);}
   StateOld=StateCur;

//   ,   
   TrueOrder=0;
   for (cnt=HistoryTotal()-1;cnt>=0;cnt--)
       {
        OrderSelect(cnt, SELECT_BY_POS, MODE_HISTORY);
        if ((OrderType()==OP_BUY) || (OrderType()==OP_SELL))
           {
            if (OrderTicket()>TrueOrder) {TrueOrder=OrderTicket();}
           }
       }

//       
   TrueBuy=0;
   for (cnt=OrdersTotal()-1;cnt>=0;cnt--)
       {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
        if (OrderType()==OP_BUY)
           {
            if (OrderTicket()>TrueBuy) {TrueBuy=OrderTicket();}
           }
        if (OrderType()==OP_SELL)
           {
            if (OrderTicket()>TrueSell) {TrueSell=OrderTicket();}
           }  
       }
       
//    (1     -1  )
   OrderSelect(TrueOrder, SELECT_BY_TICKET, MODE_HISTORY);
   if (OrderType() == 1) {StateCur=-1;}
   if (OrderType() == 0) {StateCur=1;}

//                
   if (StateCur == 1) {CalcAllPrice(OrderTakeProfit());}
   if (StateCur == -1) {CalcAllPrice(OrderTakeProfit()-Spred);}
   
//      
   DelOther();

//  ,  ... =2
   if (StateCur != StateOld) {LotCount=2;}
 
//  ,  ... *2
   if (StateCur == StateOld) {LotCount=LotCount*2;}

//   ,         
   if (StateCur==1)
      {
       for (cnt=OrdersTotal()-1;cnt>=0;cnt--)
           {
            RefreshRates();
            OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
            if ((OrderType() == OP_SELL) && (OrderTicket() != TrueSell))
               {
                ModOk=OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), BuyLimitPrice, 0, Red);
               }
           }
//     
       BSLot = LotSize(Lots);
       BLLot = LotSize(Lots);
       SSLot = LotSize(Lots);
       SLLot = LotSize(Lots)*LotCount;
      }
   if (StateCur==-1)
      {
       for (cnt=OrdersTotal()-1;cnt>=0;cnt--)
           {
            RefreshRates();
            OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
            if ((OrderType()==OP_BUY) && (OrderTicket() != TrueBuy))
               {
                ModOk=OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), SellLimitPrice, 0, Red);
               }
           }
//     
       BSLot = LotSize(Lots);
       BLLot = LotSize(Lots)*LotCount;
       SSLot = LotSize(Lots);
       SLLot = LotSize(Lots);
      }
   SetOrders (BSLot, SLLot, BLLot, SSLot);
   return (0);
  }
//+------------------------------------------------------------------+

 int DelOther() {
   for (int cnt=OrdersTotal()-1;cnt>=0;cnt--)
       {
        RefreshRates();
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
        if ((OrderType()==OP_BUYSTOP) || (OrderType()==OP_BUYLIMIT) || (OrderType()==OP_SELLSTOP) || (OrderType()==OP_SELLLIMIT))
           {
            OrderDelete(OrderTicket());
           }
       }
}

double CalcAllPrice(double SellPrice) {

   SellWorkPrice=NormalizeDouble(SellPrice,4);
   BuyWorkPrice=NormalizeDouble(SellWorkPrice+Spred,4);
   BuyStopPrice=NormalizeDouble(BuyWorkPrice+Grid*Point,4);
   BuyStopProfit=NormalizeDouble(BuyStopPrice-Spred+Grid*Point,4);
   SellLimitPrice=NormalizeDouble(SellWorkPrice+Grid*Point,4);
   SellLimitProfit=NormalizeDouble(SellLimitPrice+Spred-Grid*Point,4);
   BuyLimitPrice=NormalizeDouble(BuyWorkPrice-Grid*Point,4);
   BuyLimitProfit=NormalizeDouble(BuyLimitPrice-Spred+Grid*Point,4);
   SellStopPrice=NormalizeDouble(SellWorkPrice-Grid*Point,4);
   SellStopProfit=NormalizeDouble(SellStopPrice+Spred-Grid*Point,4);
}

int SetOrders (double L1, double L2, double L3, double L4){
  OpenOrder (Symbol(), OP_BUYSTOP, L1, BuyStopPrice, Slippage, BuyStopPrice-400*Point, BuyStopProfit, "", Magic, 0, Green);
  OpenOrder (Symbol(), OP_BUYLIMIT, L3, BuyLimitPrice, Slippage, BuyLimitPrice-400*Point, BuyLimitProfit, "", Magic, 0, Green);
  OpenOrder (Symbol(), OP_SELLLIMIT, L2, SellLimitPrice, Slippage, SellLimitPrice+400*Point, SellLimitProfit, "", Magic, 0, Red);  
  OpenOrder (Symbol(), OP_SELLSTOP, L4, SellStopPrice, Slippage, SellStopPrice+400*Point, SellStopProfit, "", Magic, 0, Red);
}

double LotSize(double lot) {
  if (FixedLot) return (lot);
  
  double res = NormalizeDouble(AccountEquity()/20000, 1);
  if (res < 1) res = 1;
  return(res);
}

int OpenOrder(string Sym, int Cmd, double Vol, double Prc, int Slp, double Stl, double Tpt, string Com, int Mag, datetime Exp, color Clr) {
  int err;
  
  int ticket=-1;
  while (ticket < 0) 
    {
     RefreshRates();
     ticket=OrderSend(Sym, Cmd, Vol, Prc, Slp, Stl, Tpt, Com, Mag, Exp, Clr);
     err=GetLastError();
     if (ticket == -1) 
        {
         Comment("err=", err, "   ", ErrorDescription(err));
         Sleep(6000);
         DelOther();
         GoFirst();
        }
     else
        {
         Comment("                                           ");
        }
    }
  Sleep(2000);
  return (ticket);
}

int GoFirst() {

  RefreshRates();
  CalcAllPrice (Bid);
  LotCount=1;
  OpenOrder (Symbol(), OP_SELL, LotSize(Lots), Bid, Slippage, Bid+400*Point, Ask-Grid*Point, "", Magic, 0, Red);
  OpenOrder (Symbol(), OP_BUY, LotSize(Lots), Ask, Slippage, Ask-400*Point, Bid+Grid*Point, "", Magic, 0, Green);
  SetOrders (LotSize(Lots), LotSize(Lots), LotSize(Lots), LotSize(Lots));
  return(0);
}

